//+------------------------------------------------------------------+
//|                                                 Active Panel.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
input bool Reset_Expert_Settings=false;//Reset settings

double Bid,Ask;         //variables for current prices
datetime time_current;  //time of last tick
int wnd=-1;             //index of the window with an indicator
bool last_loaded=false; //flag indicating whether it's a first initialization or not
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   //start the timer at intervals of 1 second
   EventSetTimer(1); 
   //get the latest prices
   get_prices();
   //define the window with an indicator
   wnd=ChartWindowFind(0,"AP");
   //if the first initialization - create interface
   if(!last_loaded) create_interface();
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   //if the deinitialisation reason isn't the timeframe or symbol change
   if(reason!=REASON_CHARTCHANGE)
     {
      //reset the initialization flag
      last_loaded=false;  
      //Delete all panel objects
      ObjectsDeleteAll_my("ActP");
      //Delete files with the saved state of the tabs
      FileDelete("Active_Panel_scheme_custom_1.bin");
      FileDelete("Active_Panel_scheme_custom_2.bin");
      FileDelete("Active_Panel_scheme_custom_3.bin");
      FileDelete("Active_Panel_scheme_custom_4.bin");
      FileDelete("Active_Panel_scheme_custom_5.bin");
     }
   //therwise set a flag
   else last_loaded=true;
   //stop the timer
   EventKillTimer();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   //get recent prices
   get_prices();
  }
//+------------------------------------------------------------------+
//| Timer handler                                                    |
//+------------------------------------------------------------------+
void OnTimer()
  {
  //panel 1 is active
   if(ObjectGetInteger(0,"ActP_main_1",OBJPROP_STATE)==1)
     {
      //if auxiliary lines are allowed
      if(ObjectGetInteger(0,"ActP_DealLines_check1",OBJPROP_STATE)==1) 
        {
         //set new values to the edit fields
         double sl_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_SL_line1",OBJPROP_PRICE),_Digits);
         //stop loss
         ObjectSetString(0,"ActP_SL_edit1",OBJPROP_TEXT,DoubleToString(sl_pr,_Digits)); 

         double tp_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_TP_line1",OBJPROP_PRICE),_Digits);
         //take profit
         ObjectSetString(0,"ActP_TP_edit1",OBJPROP_TEXT,DoubleToString(tp_pr,_Digits)); 
        }
     }

   //the same for the other tabs
   if(ObjectGetInteger(0,"ActP_main_2",OBJPROP_STATE)==1)
     {
      if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
        {
         double sl_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_SL_line2",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_SL_edit2",OBJPROP_TEXT,DoubleToString(sl_pr,_Digits));

         double tp_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_TP_line2",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_TP_edit2",OBJPROP_TEXT,DoubleToString(tp_pr,_Digits));

         double op_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_op_line2",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_Pr_edit2",OBJPROP_TEXT,DoubleToString(op_pr,_Digits));

         //add lines for the stoplimit order
         if(ObjectGetInteger(0,"ActP_limit_check2",OBJPROP_STATE)==1)
           {
            double lim_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_lim_line2",OBJPROP_PRICE),_Digits);
            ObjectSetString(0,"ActP_limpr_edit2",OBJPROP_TEXT,DoubleToString(lim_pr,_Digits));
           }

         //order expiration date
         if(ObjectGetInteger(0,"ActP_exp3_radio2",OBJPROP_STATE)==1)
            ObjectSetString(0,"ActP_exp_edit2",OBJPROP_TEXT,TimeToString(ObjectGetInteger(0,"ActP_exp_line2",OBJPROP_TIME)));
        }
     }

   if(ObjectGetInteger(0,"ActP_main_3",OBJPROP_STATE)==1)
     {
      if(ObjectGetInteger(0,"ActP_DealLines_check4",OBJPROP_STATE)==1)
        {
         double sl_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_SL_line4",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_SL_edit4",OBJPROP_TEXT,DoubleToString(sl_pr,_Digits));

         double tp_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_TP_line4",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_TP_edit4",OBJPROP_TEXT,DoubleToString(tp_pr,_Digits));

         double op_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_op_line4",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_Pr_edit4",OBJPROP_TEXT,DoubleToString(op_pr,_Digits));
        }

      if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
        {
         double sl_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_SL_line3",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_SL_edit3",OBJPROP_TEXT,DoubleToString(sl_pr,_Digits));

         double tp_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_TP_line3",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_TP_edit3",OBJPROP_TEXT,DoubleToString(tp_pr,_Digits));

         double op_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_op_line3",OBJPROP_PRICE),_Digits);
         ObjectSetString(0,"ActP_Pr_edit3",OBJPROP_TEXT,DoubleToString(op_pr,_Digits));

         if(ObjectGetInteger(0,"ActP_limit_check3",OBJPROP_STATE)==1)
           {
            double lim_pr=NormalizeDouble(ObjectGetDouble(0,"ActP_lim_line3",OBJPROP_PRICE),_Digits);
            ObjectSetString(0,"ActP_limpr_edit3",OBJPROP_TEXT,DoubleToString(lim_pr,_Digits));
           }

         if(ObjectGetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE)==1)
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,TimeToString(ObjectGetInteger(0,"ActP_exp_line3",OBJPROP_TIME)));
        }
     }
   //redraw chart
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| OnChartEvent handler                                             |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
   //Event - click on the chart
   if(id==CHARTEVENT_CLICK)
     {
      //delete drow down lists
      DeleteLists("ActP_orders_list_"); 
      DeleteLists("ActP_color_list_");
      //and set the list buttons to the unpressed state
      ObjectSetInteger(0,"ActP_ord_button5",OBJPROP_STATE,0);
      ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
      ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
      ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
      ChartRedraw();
      return;
     }

   //end edit event
   if(id==CHARTEVENT_OBJECT_ENDEDIT)
     {
      //******************************************
      //if edit field is SL field
      if(sparam=="ActP_SL_edit1")
        {
         //and auxiliary lines are enabled
         if(ObjectGetInteger(0,"ActP_DealLines_check1",OBJPROP_STATE)==1)
           {
            //get text from the field
            double sl_val=StringToDouble(ObjectGetString(0,"ActP_SL_edit1",OBJPROP_TEXT));
            //move lines at new position
            ObjectSetDouble(0,"ActP_SL_line1",OBJPROP_PRICE,sl_val);
           }
         //redraw chart
         ChartRedraw();
         //it ins't necessary to proceed the other objects, because the event from the one
         return;
        }
      //the same for the other edit fields
      if(sparam=="ActP_TP_edit1")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check1",OBJPROP_STATE)==1)
           {
            double tp_val=StringToDouble(ObjectGetString(0,"ActP_TP_edit1",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_TP_line1",OBJPROP_PRICE,tp_val);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(sparam=="ActP_SL_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            double sl_val=StringToDouble(ObjectGetString(0,"ActP_SL_edit2",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_SL_line2",OBJPROP_PRICE,sl_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_TP_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            double tp_val=StringToDouble(ObjectGetString(0,"ActP_TP_edit2",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_TP_line2",OBJPROP_PRICE,tp_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_Pr_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            double op_val=StringToDouble(ObjectGetString(0,"ActP_Pr_edit2",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_op_line2",OBJPROP_PRICE,op_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_limpr_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            double lim_val=StringToDouble(ObjectGetString(0,"ActP_limpr_edit2",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,lim_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_exp_edit2")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
           {
            datetime exp_val=StringToTime(ObjectGetString(0,"ActP_exp_edit2",OBJPROP_TEXT));
            ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,exp_val);
           }
         ChartRedraw();
         return;
        }
      //******************************************      
      if(sparam=="ActP_SL_edit4")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check4",OBJPROP_STATE)==1)
           {
            double sl_val=StringToDouble(ObjectGetString(0,"ActP_SL_edit4",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_SL_line4",OBJPROP_PRICE,sl_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_TP_edit4")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check4",OBJPROP_STATE)==1)
           {
            double tp_val=StringToDouble(ObjectGetString(0,"ActP_TP_edit4",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_TP_line4",OBJPROP_PRICE,tp_val);
           }
         ChartRedraw();
         return;
        }
      //******************************************   
      if(sparam=="ActP_SL_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            double sl_val=StringToDouble(ObjectGetString(0,"ActP_SL_edit3",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_SL_line3",OBJPROP_PRICE,sl_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_TP_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            double tp_val=StringToDouble(ObjectGetString(0,"ActP_TP_edit3",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_TP_line3",OBJPROP_PRICE,tp_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_Pr_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            double op_val=StringToDouble(ObjectGetString(0,"ActP_Pr_edit3",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_op_line3",OBJPROP_PRICE,op_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_limpr_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            double lim_val=StringToDouble(ObjectGetString(0,"ActP_limpr_edit3",OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_lim_line3",OBJPROP_PRICE,lim_val);
           }
         ChartRedraw();
         return;
        }
      if(sparam=="ActP_exp_edit3")
        {
         if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
           {
            datetime exp_val=StringToTime(ObjectGetString(0,"ActP_exp_edit3",OBJPROP_TEXT));
            ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,exp_val);
           }
         ChartRedraw();
         return;
        }

      //font size edit
      if(sparam=="ActP_font_edit6")
        {
        //set font for all control elements
         SetFontSize(int(StringToInteger(ObjectGetString(0,sparam,OBJPROP_TEXT))));
        }
      //******************************************          
     }

   //Event - click on the graphic object
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      //******************************************
      //Buy button click
      if(sparam=="ActP_buy_button1")
        {
         //check button state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //if it pressed
         if(selected)
           {
            //try to perform a deal
            deal(ORDER_TYPE_BUY);
            //set button to the unpressed state
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         //redraw chart
         ChartRedraw();
         //finish execution of function
         return;
        }
      //******************************************
      //the same for the Sell button
      if(sparam=="ActP_sell_button1")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            deal(ORDER_TYPE_SELL);
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      //Buy pending order click
      if(sparam=="ActP_buy_button2")
        {
         //check button state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //if pressed
         if(selected)
           {
            ENUM_ORDER_TYPE typ;
            //get order price
            double pr=NormalizeDouble(StringToDouble(ObjectGetString(0,"ActP_Pr_edit2",OBJPROP_TEXT)),Digits());
            //if order type is not stoplimit
            if(ObjectGetInteger(0,"ActP_limit_check2",OBJPROP_STATE)==0)
              {
               //if order price is below the current price, set limit order
               if(Ask>pr) typ=ORDER_TYPE_BUY_LIMIT;
               //overwise - stop order
               else typ=ORDER_TYPE_BUY_STOP;
              }
            //if stop limit order
            else
              {
              //set operation type
               typ=ORDER_TYPE_BUY_STOP_LIMIT; 
              }
            //try to place order
            order(typ);
            //set button state to unpressed
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         //redraw chart
         ChartRedraw();
         //finish the execution of function
         return;
        }
      //******************************************  
      //the same for the sell pending order
      if(sparam=="ActP_sell_button2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            ENUM_ORDER_TYPE typ;
            double pr=NormalizeDouble(StringToDouble(ObjectGetString(0,"ActP_Pr_edit2",OBJPROP_TEXT)),Digits());
            if(ObjectGetInteger(0,"ActP_limit_check2",OBJPROP_STATE)==0)
              {
               if(Bid<pr) typ=ORDER_TYPE_SELL_LIMIT;
               else typ=ORDER_TYPE_SELL_STOP;
              }
            else
              {
               typ=ORDER_TYPE_SELL_STOP_LIMIT;
              }
            order(typ);
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************        
      //click on the position modify button
      if(sparam=="ActP_mod_button4")
        {
         //check state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //if pressed
         if(selected)
           {
            //modify position
            modify_pos();
            //delete scheme objects
            DeleteScheme("ActP",true);
            //and reset them (update interface)
            SetScheme(0);
            //set button to unpressed state
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0); 
           }
         //redraw chart
         ChartRedraw();
         //finish the execution of function
         return;
        }
      //******************************************        
      //Close position button click
      if(sparam=="ActP_del_button4")
        {
        //check button state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //if it pressed
         if(selected)
           {
            //try to close
            ulong retcode=close_pos();
            //if successful
            if(retcode==10009)
              {
               //delete scheme objects
               DeleteScheme("ActP",true);
               //set new button text for the list
               ObjectSetString(0,"ActP_ord_button5",OBJPROP_TEXT,"Select an order -->");
              }
            //set button state to unpressed
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         //redraw chart
         ChartRedraw();
         //finish the execution of function
         return;
        }
      //******************************************   
      //order delete button click
      if(sparam=="ActP_del_button3")
        {
         //check button state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //if it pressed
         if(selected)
           {
           //get order ticket from the list
            string button_name=ObjectGetString(0,"ActP_ord_button5",OBJPROP_TEXT);
            long ticket=StringToInteger(StringSubstr(button_name, 1, StringFind(button_name, " ")-1));
            //try to delete pending order
            ulong retcode=del_order(ticket);
            //if successful
            if(retcode==10009)
              {
               //delete scheme objects
               DeleteScheme("ActP",true);
               //set new text for the list
               ObjectSetString(0,"ActP_ord_button5",OBJPROP_TEXT,"Select an order -->");
              } 
            //set button state to unpressed
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         //redraw chart
         ChartRedraw();
         //finish the execution of function
         return;
        }
      //****************************************** 
      //order modify button click
      if(sparam=="ActP_mod_button3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            //get order ticket from the list button
            string button_name=ObjectGetString(0,"ActP_ord_button5",OBJPROP_TEXT);
            ulong ticket=StringToInteger(StringSubstr(button_name,1,StringFind(button_name," ")-1));
            //modify order
            modify_order(ticket);
            //update interface
            DeleteScheme("ActP",true);
            SetScheme(ticket);
            //set button state to unpressed
            ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
           }
         //redraw chart
         ChartRedraw();
         //finish the execution of function
         return;
        }
      //******************************************                                     
      //stoplimit order check click
      if(sparam=="ActP_limit_check2")
        {
         //check flag state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //if flag is set
         if(selected)
           {
            //set new color for the price edit field
            ObjectSetInteger(0,"ActP_limpr_edit2",OBJPROP_BGCOLOR,White);
            //enable it for the edit
            ObjectSetInteger(0,"ActP_limpr_edit2",OBJPROP_READONLY,false);
            //put current price to the edit
            ObjectSetString(0,"ActP_limpr_edit2",OBJPROP_TEXT,DoubleToString(Bid,_Digits));
            //if auxiliary lines are enabled
            //move them
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,Bid);
           }
         //if flag is unset
         else
           {
            //disable it for the edit
            ObjectSetInteger(0,"ActP_limpr_edit2",OBJPROP_BGCOLOR,LavenderBlush);
            //set color
            ObjectSetInteger(0,"ActP_limpr_edit2",OBJPROP_READONLY,true);
            //and "empty" text
            ObjectSetString(0,"ActP_limpr_edit2",OBJPROP_TEXT,"");
            //if auxiliary lines are enabled
            //move them at the 0 price
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,0);
           }
        }
      //******************************************                
      //click on the auxiliary lines check for position
      if(sparam=="ActP_DealLines_check1")
        {
         //check flag state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //if it set
         if(selected)
           {
            //get SL and TP from the edits
            string SL_txt=ObjectGetString(0,"ActP_SL_edit1",OBJPROP_TEXT);
            string TP_txt=ObjectGetString(0, "ActP_TP_edit1", OBJPROP_TEXT);
            double val_SL,val_TP;
            //if SL isn't empty
            //save it
            if(SL_txt!="")
               val_SL=StringToDouble(SL_txt);
            //if it empty
            else
              {
              //get max and min price on the chart
               double pr_max=ChartGetDouble(0,CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               //set stop at 1/3 of the chart
               val_SL=pr_min+(pr_max-pr_min)*0.33;
              }

            //the same is with the TP
            if(TP_txt!="")
               val_TP=StringToDouble(TP_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_TP=pr_max-(pr_max-pr_min)*0.33;
              }
            //move lines at new positions
            ObjectSetDouble(0,"ActP_SL_line1",OBJPROP_PRICE,val_SL);
            ObjectSetDouble(0,"ActP_TP_line1",OBJPROP_PRICE,val_TP);
           }
         //if flag is unset
         //remove the lines
         else
           {
            ObjectSetDouble(0,"ActP_SL_line1",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_TP_line1",OBJPROP_PRICE,0);
           }
         //redraw chart
         ChartRedraw();
         //finish execution of function
         return;
        }
      //******************************************
      //auxiliary lines check click for pending order
      if(sparam=="ActP_DealLines_check2")
        {
         //check flag state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //if flag is set
         if(selected)
           {
           //get parameters from the edits
            string SL_txt=ObjectGetString(0,"ActP_SL_edit2",OBJPROP_TEXT);
            string TP_txt=ObjectGetString(0, "ActP_TP_edit2", OBJPROP_TEXT);
            string PR_txt=ObjectGetString(0, "ActP_Pr_edit2", OBJPROP_TEXT);
            string LIM_txt=ObjectGetString(0,"ActP_limpr_edit2",OBJPROP_TEXT);
            double val_SL,val_TP,val_op,val_lim;

            //similar as position open
            if(SL_txt!="")
               val_SL=StringToDouble(SL_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_SL=pr_min+(pr_max-pr_min)*0.33;
              }

            if(TP_txt!="")
               val_TP=StringToDouble(TP_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_TP=pr_max-(pr_max-pr_min)*0.33;
              }

            if(PR_txt!="")
               val_op=StringToDouble(PR_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_op=pr_max-(pr_max-pr_min)*0.5;
              }

            if(LIM_txt!="")
               val_lim=StringToDouble(LIM_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_lim=pr_min+(pr_max-pr_min)*0.25;
              }

            if(LIM_txt!="")
               val_lim=StringToDouble(LIM_txt);
            else
              {
               double pr_max=ChartGetDouble(0, CHART_PRICE_MAX);
               double pr_min=ChartGetDouble(0, CHART_PRICE_MIN);
               val_lim=pr_min+(pr_max-pr_min)*0.25;
              }

            datetime val_exp=StringToTime(ObjectGetString(0,"ActP_exp_edit2",OBJPROP_TEXT));

            ObjectSetDouble(0,"ActP_SL_line2",OBJPROP_PRICE,val_SL);
            ObjectSetDouble(0,"ActP_TP_line2",OBJPROP_PRICE,val_TP);
            ObjectSetDouble(0,"ActP_op_line2",OBJPROP_PRICE,val_op);
            ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,val_lim);
            ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,val_exp);
           }
         else
           {
            ObjectSetDouble(0,"ActP_SL_line2",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_TP_line2",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_Pr_line2",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_lim_line2",OBJPROP_PRICE,0);
            ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************     
      //auxiliary lines check click for the case of the pending order modify
      if(sparam=="ActP_DealLines_check3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            string SL_txt=ObjectGetString(0, "ActP_SL_edit3", OBJPROP_TEXT);
            string TP_txt=ObjectGetString(0, "ActP_TP_edit3", OBJPROP_TEXT);
            string PR_txt=ObjectGetString(0, "ActP_Pr_edit3", OBJPROP_TEXT);
            string LIM_txt=ObjectGetString(0,"ActP_limpr_edit3",OBJPROP_TEXT);
            double val_SL=StringToDouble(SL_txt), val_TP=StringToDouble(TP_txt);
            double val_op=StringToDouble(PR_txt), val_lim=StringToDouble(LIM_txt);
            datetime val_exp=StringToTime(ObjectGetString(0,"ActP_exp_edit3",OBJPROP_TEXT));

            ObjectSetDouble(0,"ActP_SL_line3",OBJPROP_PRICE,val_SL);
            ObjectSetDouble(0,"ActP_TP_line3",OBJPROP_PRICE,val_TP);
            ObjectSetDouble(0,"ActP_op_line3",OBJPROP_PRICE,val_op);
            ObjectSetDouble(0,"ActP_lim_line3",OBJPROP_PRICE,val_lim);
            ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,val_exp);
           }
         else
           {
            ObjectSetDouble(0,"ActP_SL_line3",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_TP_line3",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_Pr_line3",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_lim_line3",OBJPROP_PRICE,0);
            ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      //auxiliary lines check click for the case of open position modify
      if(sparam=="ActP_DealLines_check4")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            double op_pr=StringToDouble(ObjectGetString(0,"ActP_Pr_edit4",OBJPROP_TEXT));
            double sl=StringToDouble(ObjectGetString(0, "ActP_SL_edit4", OBJPROP_TEXT));
            double tp=StringToDouble(ObjectGetString(0, "ActP_TP_edit4", OBJPROP_TEXT));
            ObjectSetDouble(0,"ActP_op_line4",OBJPROP_PRICE,op_pr);
            ObjectSetDouble(0,"ActP_SL_line4",OBJPROP_PRICE,sl);
            ObjectSetDouble(0,"ActP_TP_line4",OBJPROP_PRICE,tp);
           }
         else
           {
            ObjectSetDouble(0,"ActP_op_line4",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_SL_line4",OBJPROP_PRICE,0);
            ObjectSetDouble(0,"ActP_TP_line4",OBJPROP_PRICE,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      //Radio1 click deal execution type
      if(sparam=="ActP_Exe1_radio1")
        {
        //check the state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //set state
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         //if its state is 1 of 2
         if(selected)
           {
            //reset the second radio
            ObjectSetInteger(0,"ActP_Exe2_radio1",OBJPROP_STATE,false);
            //redraw chart
            ChartRedraw();
            //finish the execution of function
            return;
           }
         //redraw chart
         ChartRedraw();
         //finish the execution of function
         return;
        }

      //the similar for the radion2
      if(sparam=="ActP_Exe2_radio1")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_Exe1_radio1",OBJPROP_STATE,false);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }
      //******************************************
      //click on the radio 1 - order expiration type
      if(sparam=="ActP_Exe1_radio2")
        {
         //check for the state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //set state
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         //if state 1 of 3
           if(selected)
           {
            //reset other radio buttons
            ObjectSetInteger(0,"ActP_Exe2_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_Exe3_radio2",OBJPROP_STATE,false);
            //redraw chart
            ChartRedraw();
            //finish the execution of function
            return;
           }
         //redraw chart
         ChartRedraw();
         //finish the execution of function
         return;
        }

      //the similar for the radio2  
      if(sparam=="ActP_Exe2_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_Exe1_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_Exe3_radio2",OBJPROP_STATE,false);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }

      //the similar for the radio 3
      if(sparam=="ActP_Exe3_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_Exe1_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_Exe2_radio2",OBJPROP_STATE,false);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(sparam=="ActP_exp1_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp2_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp3_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_READONLY,true);
            ObjectSetString(0,"ActP_exp_edit2",OBJPROP_TEXT,"");
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,0);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }

      if(sparam=="ActP_exp2_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp1_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp3_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_READONLY,true);
            ObjectSetString(0,"ActP_exp_edit2",OBJPROP_TEXT,"");
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,0);
            ChartRedraw();
            return;
           }
         ChartRedraw();
         return;
        }

      if(sparam=="ActP_exp3_radio2")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp1_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp2_radio2",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_BGCOLOR,White);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_READONLY,false);
            ObjectSetString(0,"ActP_exp_edit2",OBJPROP_TEXT,TimeToString(time_current));
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,time_current);
            ChartRedraw();
            return;
           }
         else
           {
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit2",OBJPROP_READONLY,true);
            if(ObjectGetInteger(0,"ActP_DealLines_check2",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line2",OBJPROP_TIME,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(sparam=="ActP_exp1_radio3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_READONLY,true);
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,"");
            if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,0);
            ChartRedraw();
            return;
           }
        }

      if(sparam=="ActP_exp2_radio3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_READONLY,true);
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,"");
            if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,0);
            ChartRedraw();
            return;
           }
        }

      if(sparam=="ActP_exp3_radio3")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,1);
         if(selected)
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,false);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_BGCOLOR,White);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_READONLY,false);
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,TimeToString(time_current));
            if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,time_current);
            ChartRedraw();
            return;
           }
         else
           {
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_BGCOLOR,LavenderBlush);
            ObjectSetInteger(0,"ActP_exp_edit3",OBJPROP_READONLY,true);
            if(ObjectGetInteger(0,"ActP_DealLines_check3",OBJPROP_STATE)==1)
               ObjectSetInteger(0,"ActP_exp_line3",OBJPROP_TIME,0);
           }
         ChartRedraw();
         return;
        }
      //******************************************      
      //click on the panel
      //here we execute the corresponding operarions
      if(sparam=="ActP_main_1") {Main_controls_click(1); ChartRedraw(); return;}
      if(sparam=="ActP_main_2") {Main_controls_click(2); ChartRedraw(); return;}
      if(sparam=="ActP_main_3") {Main_controls_click(3); ChartRedraw(); return;}
      if(sparam=="ActP_main_4") {Main_controls_click(4); ChartRedraw(); return;}
      if(sparam=="ActP_main_5") {Main_controls_click(5); ChartRedraw(); return;}
      //******************************************
      //click on the select order list activation button
      if(sparam=="ActP_ord_button5")
        {
         //check state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //list is active
         if(selected)
           {
            //delete scheme
            DeleteScheme("ActP",true);
            //array for the orders
            string info[100];
            //array for the tickets
            ulong tickets[100];
            //initialize it
            ArrayInitialize(tickets,-1);
            //get order info
            get_ord_info(info, tickets);
            //and create the list
            create_list(info,tickets);
           }
         //list isn't active
         else
           {
            //then delete it
            DeleteLists("ActP_orders_list_");
           }
         //redraw chart
         ChartRedraw();
         //finish the execution of function
         return;
        }
      //******************************************       
      //it isn't order element list click'
      if(StringFind(sparam,"ActP_orders_list_")<0)
        {
         //delete it
         DeleteLists("ActP_orders_list_");
         //set activation list button as unpressed
         ObjectSetInteger(0,"ActP_ord_button5",OBJPROP_STATE,0);
         //redraw chart
         ChartRedraw();
        }
      //click on the select order list
      else
        {
         //set new name for the activation button
         ObjectSetString(0,"ActP_ord_button5",OBJPROP_TEXT,ObjectGetString(0,sparam,OBJPROP_TEXT));
         //set activation button as unpressed
         ObjectSetInteger(0,"ActP_ord_button5",OBJPROP_STATE,0);
         //get ticket from the list element
         ulong ticket=StringToInteger(StringSubstr(sparam,StringFind(sparam,"$")+1));
         //load interface
         SetScheme(ticket);
         //and delete list
         DeleteLists("ActP_orders_list_");
         //redraw chart
         ChartRedraw();
        }
      //******************************************   
      //click on the color list activarion button
      if(sparam=="ActP_col1_button6")
        {
        //check state
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         //list is active
         if(selected)
           {
            //create color list
            create_color_list(100,"ActP_col1_button6",1);
            //set other buttons position as unpressed
            ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
            //delete other lists
            DeleteLists("ActP_color_list_2");
            DeleteLists("ActP_color_list_3");
           }
         //list isn't active
         else
           {
            //delete it
            DeleteLists("ActP_color_list_"); 
           }
         //redraw chart
         ChartRedraw();
         //finish the execution of function
         return;
        }
      //******************************************
      //it isn't the click on the color list
      if(StringFind(sparam,"ActP_color_list_1")<0)
        {
         //delete list
         DeleteLists("ActP_color_list_1"); 
         //set list activation button as unpressed
         ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
         //redraw chart
         ChartRedraw(); 
        }
      //click on the color list element
      else
        {
         //get color from the list element
         color col=color(ObjectGetInteger(0,sparam,OBJPROP_BGCOLOR));
         //and set it for all buttons
         SetButtonsColor(col);
         //set activation button as unpressed
         ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
         //delete list
         DeleteLists("ActP_color_list_1");
         //redraw chart
         ChartRedraw();
        }
      //******************************************     
      //similar for the other color activation lists
      if(sparam=="ActP_col2_button6")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            create_color_list(100,"ActP_col2_button6",2);
            //set unpressed for the other buttons
            ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
            //delete other lists
            DeleteLists("ActP_color_list_3");
            DeleteLists("ActP_color_list_1");
           }
         else
           {
            DeleteLists("ActP_color_list_2");
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(StringFind(sparam,"ActP_color_list_2")<0)
        {
         DeleteLists("ActP_color_list_2");
         ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
         ChartRedraw();
         //return;
        }
      else
        {
         color col=color(ObjectGetInteger(0,sparam,OBJPROP_BGCOLOR));
         SetLabelsColor(col);
         ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
         DeleteLists("ActP_color_list_2");
         ChartRedraw();
        }
      //******************************************     
      if(sparam=="ActP_col3_button6")
        {
         bool selected=ObjectGetInteger(0,sparam,OBJPROP_STATE);
         if(selected)
           {
            create_color_list(100,"ActP_col3_button6",3);
            //set other buttons as unpressed
            ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
            //delete all lists
            DeleteLists("ActP_color_list_2");
            DeleteLists("ActP_color_list_1");
           }
         else
           {
            DeleteLists("ActP_color_list_3");
           }
         ChartRedraw();
         return;
        }
      //******************************************
      if(StringFind(sparam,"ActP_color_list_3")<0)
        {
         DeleteLists("ActP_color_list_3");
         ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
         ChartRedraw();
        }
      else
        {
         color col=color(ObjectGetInteger(0,sparam,OBJPROP_BGCOLOR));
         SetTextColor(col);
         ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
         DeleteLists("ActP_color_list_3");
         ChartRedraw();
        }
      //******************************************                 
     }
  }
//+------------------------------------------------------------------+
//| The function sets color for all buttons                          |
//| col - color                                                      |
//+------------------------------------------------------------------+
void SetButtonsColor(color col)
  {
   //we will go through all the objects
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //if the object belongs to the panel and its has a button type
      //set color
      if(StringFind(n,"ActP")>=0 && ObjectGetInteger(0,n,OBJPROP_TYPE)==OBJ_BUTTON) 
         ObjectSetInteger(0,n,OBJPROP_BGCOLOR,col); 
     }
   //set global variable
   GlobalVariableSet("ActP_buttons_color",col);
  }
//+------------------------------------------------------------------+
//| The function sets color for all labels                           |
//| col - labels color                                               |
//+------------------------------------------------------------------+
void SetLabelsColor(color col)
  {
   //we will go through all the objects
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //if the object belongs to the panel and its has a label type
      //set color
      if(StringFind(n,"ActP")>=0 && ObjectGetInteger(0,n,OBJPROP_TYPE)==OBJ_LABEL) 
         ObjectSetInteger(0,n,OBJPROP_COLOR,col); 
     }
   //set global variable
   GlobalVariableSet("ActP_label_color",col);
  }
//+------------------------------------------------------------------+
//| The function sets text color for all buttons and edits           |
//| col - text color                                                 |
//+------------------------------------------------------------------+
void SetTextColor(color col)
  {
   //we will go through all the objects
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      long obj_type=ObjectGetInteger(0,n,OBJPROP_TYPE);
      //if the object belongs to the panel and its has a button or edit type
      //set color
      if(StringFind(n,"ActP")>=0 && (obj_type==OBJ_BUTTON || obj_type==OBJ_EDIT)) 
         ObjectSetInteger(0,n,OBJPROP_COLOR,col); 
     }
   //set global variable
   GlobalVariableSet("ActP_text_color",col);
  }
//+------------------------------------------------------------------+
//| The function sets font color                                     |
//| font_size - new font size                                        |
//+------------------------------------------------------------------+
void SetFontSize(int font_size)
  {
   //if font size is too large, decrease it
   if(font_size>10) font_size=10;
   //we will go through all the objects
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      int obj_type=int(ObjectGetInteger(0,n,OBJPROP_TYPE));
      //if the object belongs to the panel and its has a label or button type
      //set font size
      if(StringFind(n,"ActP")>=0 && (obj_type==OBJ_EDIT || obj_type==OBJ_LABEL)) 
         ObjectSetInteger(0,n,OBJPROP_FONTSIZE,font_size); 
     }
   //set global variable
   GlobalVariableSet("ActP_font_size",font_size);
  }
//+------------------------------------------------------------------+
//| Set position parameters for the objects                          |
//+------------------------------------------------------------------+
void SetPositionParams()
  {
   //if position is exists
   if(PositionSelect(Symbol()))
     {
      //get its parameters
      double pr=PositionGetDouble(POSITION_PRICE_OPEN);
      double lots=PositionGetDouble(POSITION_VOLUME);
      double sl=PositionGetDouble(POSITION_SL);
      double tp=PositionGetDouble(POSITION_TP);
      int mag=int(PositionGetInteger(POSITION_MAGIC));
      //and set new values to the objects
      ObjectSetString(0,"ActP_Pr_edit4",OBJPROP_TEXT,str_del_zero(DoubleToString(pr)));
      ObjectSetString(0,"ActP_lots_edit4",OBJPROP_TEXT,str_del_zero(DoubleToString(lots)));
      ObjectSetString(0,"ActP_SL_edit4",OBJPROP_TEXT,str_del_zero(DoubleToString(sl)));
      ObjectSetString(0,"ActP_TP_edit4",OBJPROP_TEXT,str_del_zero(DoubleToString(tp)));
      if(mag!=0) ObjectSetString(0,"ActP_mag_edit4",OBJPROP_TEXT,IntegerToString(mag));
      //redraw chart
      ChartRedraw();
     }
   //if there isn't position, show message 
   else MessageBox("There isn't open position for "+Symbol());
  }
//+------------------------------------------------------------------+
//| Set pending order parameters for the objects                     |
//| ticket - order ticket                                            |
//+------------------------------------------------------------------+
void SetOrderParams(long ticket)
  {
   //if order exists
   if(OrderSelect(ticket) && OrderGetString(ORDER_SYMBOL)==Symbol())
     {
      //get its parameters
      double pr=OrderGetDouble(ORDER_PRICE_OPEN);
      double lots=OrderGetDouble(ORDER_VOLUME_CURRENT);
      double sl=OrderGetDouble(ORDER_SL);
      double tp=OrderGetDouble(ORDER_TP);
      int mag=int(OrderGetInteger(ORDER_MAGIC));
      double lim=OrderGetDouble(ORDER_PRICE_STOPLIMIT);
      datetime expir=datetime(OrderGetInteger(ORDER_TIME_EXPIRATION));
      ENUM_ORDER_TYPE type=ENUM_ORDER_TYPE (OrderGetInteger(ORDER_TYPE));
      ENUM_ORDER_TYPE_TIME expir_type=ENUM_ORDER_TYPE_TIME(OrderGetInteger(ORDER_TYPE_TIME));
      
      //of order type is stoplimit, modify the interface
      if(type==ORDER_TYPE_BUY_STOP_LIMIT || type==ORDER_TYPE_SELL_STOP_LIMIT)
        {
         //set new value to the order price edit
         ObjectSetString(0,"ActP_limpr_edit3",OBJPROP_TEXT,DoubleToString(lim,_Digits));
         ObjectSetInteger(0,"ActP_limpr_edit3",OBJPROP_BGCOLOR,White);
         //set order price available for edit
         ObjectSetInteger(0,"ActP_limpr_edit3",OBJPROP_READONLY,false);
        }
      //if order type isn't stoplimit, modify the interface
      else
        {
         ObjectSetString(0,"ActP_limpr_edit3",OBJPROP_TEXT,"");
         ObjectSetInteger(0,"ActP_limpr_edit3",OBJPROP_BGCOLOR,LavenderBlush);
         ObjectSetInteger(0,"ActP_limpr_edit3",OBJPROP_READONLY,true);
        }

     //check expiration type
     //and set interface elements    
      switch(expir_type)
        {
         case ORDER_TIME_GTC:
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,1);
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,0);
            break;
           }
         case ORDER_TIME_DAY:
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,1);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,0);
            break;
           }
         case ORDER_TIME_SPECIFIED:
           {
            ObjectSetInteger(0,"ActP_exp1_radio3",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_exp2_radio3",OBJPROP_STATE,0);
            ObjectSetInteger(0,"ActP_exp3_radio3",OBJPROP_STATE,1);
            //in addition, set new value to the edit
            ObjectSetString(0,"ActP_exp_edit3",OBJPROP_TEXT,TimeToString(expir));
            break;
           }
        }
      //set new values for the objects
      ObjectSetString(0,"ActP_Pr_edit3",OBJPROP_TEXT,str_del_zero(DoubleToString(pr)));
      ObjectSetString(0,"ActP_lots_edit3",OBJPROP_TEXT,str_del_zero(DoubleToString(lots)));
      ObjectSetString(0,"ActP_SL_edit3",OBJPROP_TEXT,str_del_zero(DoubleToString(sl)));
      ObjectSetString(0,"ActP_TP_edit3",OBJPROP_TEXT,str_del_zero(DoubleToString(tp)));
      ObjectSetString(0,"ActP_ticket_edit3",OBJPROP_TEXT,IntegerToString(ticket));
      if(mag!=0) ObjectSetString(0,"ActP_mag_edit3",OBJPROP_TEXT,IntegerToString(mag));
      ChartRedraw();
     }
   //if there isn't such order, show message
   else MessageBox("There isn't an order with ticket "+IntegerToString(ticket)+" for "+Symbol());
  }

//+------------------------------------------------------------------+
//| The function sets the interface depending on type:               |
//| position or pending order                                        |
//| t - ticket                                                       |
//+------------------------------------------------------------------+
void SetScheme(ulong t)
  {
   //if position
   if(t==0)
     {
      //check for its presence
      if(PositionSelect(Symbol()))
        {
         //delete old scheme
         DeleteScheme("ActP",true);
         //and apply new
         ApplyScheme(6);
         //set position parameters
         SetPositionParams();
         //the objects are unavailable for the selection
         Objects_Selectable("ActP",false);
        }
     }
   //if order
   if(t>0)
     {
      //check for its presence
      if(OrderSelect(t))
        {
         //delete old scheme
         DeleteScheme("ActP",true);
         //and apply new
         ApplyScheme(7);
         //set order parameters
         SetOrderParams(t);
         //the objects are unavailable for the selection
         Objects_Selectable("ActP",false);
        }
     }
  }
//+------------------------------------------------------------------+
//| The function creates list of positions                           |
//| info - array for the positions                                   |
//| tickets - array for the tickets                                  |
//+------------------------------------------------------------------+
void create_list(string &info[],ulong &tickets[])
  {
   //get the coordinates of the list activation button
   int x=int(ObjectGetInteger(0,"ActP_ord_button5",OBJPROP_XDISTANCE));
   int y=int(ObjectGetInteger(0, "ActP_ord_button5", OBJPROP_YDISTANCE)+ObjectGetInteger(0, "ActP_ord_button5", OBJPROP_YSIZE));
   //get colors
   color col=color(ObjectGetInteger(0,"ActP_ord_button5",OBJPROP_COLOR));
   color bgcol=color(ObjectGetInteger(0,"ActP_ord_button5",OBJPROP_BGCOLOR));
   //get window height
   int wnd_height=int(ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,wnd));
   int y_cnt=0;
   //proceed arrays
   for(int i=0;i<100;i++)
     {
      //break if end reached
      if(tickets[i]==-1) break;
      //calculate the list item coordinates
      int y_pos=y+y_cnt*20;
      //if the windiow limits are reachedl, start a new column
      if(y_pos+20>wnd_height) {x+=300; y_cnt=0;}
      y_pos=y+y_cnt*20;
      y_cnt++;
      string name="ActP_orders_list_"+IntegerToString(i)+" $"+IntegerToString(tickets[i]);
      //create element
      create_button(name,info[i],x,y_pos,300,20);
      //and set its properties
      ObjectSetInteger(0,name,OBJPROP_COLOR,col);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,name,OBJPROP_STATE,0);
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,8);
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bgcol);
     }
  }
//+------------------------------------------------------------------+
//| Function for creating the colors list                            |
//| y_max - maximal list width                                       |
//| ID - list ID                                                     |
//| num - interface number                                           |
//+------------------------------------------------------------------+
void create_color_list(int y_max,string ID,int num)
  {
  //Get the coordinates of the list activation button
   int x=int(ObjectGetInteger(0,ID,OBJPROP_XDISTANCE));
   int y=int(ObjectGetInteger(0, ID, OBJPROP_YDISTANCE)+ObjectGetInteger(0, ID, OBJPROP_YSIZE));
   //get color
   color col=color(ObjectGetInteger(0,ID,OBJPROP_COLOR));
   //and window width
   int wnd_height=int(ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,wnd));
   y_max+=y;
   int y_cnt=0;
   //We will go through the colors array
   for(int i=0;i<132;i++)
     {
      color bgcol=colors[i];
      //calculate list item coordinates
      int y_pos=y+y_cnt*20;
      //if we reached the boundaries of the window, start new column
      if(y_pos+20>wnd_height || y_pos+20>y_max) {x+=20; y_cnt=0;}
      y_pos=y+y_cnt*20;
      y_cnt++;
      //create new element
      string name="ActP_color_list_"+IntegerToString(num)+ID+IntegerToString(i);
      create_button(name,"",x,y_pos,20,20);
      //and set its properties
      ObjectSetInteger(0,name,OBJPROP_COLOR,col);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,name,OBJPROP_STATE,0);
      ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bgcol);
     }
  }

//+------------------------------------------------------------------+
//| The function for obtaining the information about orders          |
//+------------------------------------------------------------------+
void get_ord_info(string &info[],ulong &tickets[])
  {
   //initialize the counter
   int cnt=0;
   string inf;
   //if there is an open position
   if(PositionSelect(Symbol()))
     {
     //combine all order infomation in a single line
      double vol=PositionGetDouble(POSITION_VOLUME);
      int typ=int(PositionGetInteger(POSITION_TYPE));
      if(typ==POSITION_TYPE_BUY) inf+="BUY ";
      if(typ==POSITION_TYPE_SELL) inf+="SELL ";
      inf+=DoubleToString(vol, int(MathCeil(MathAbs(MathLog(vol)/MathLog(10)))))+" lots";
      inf+=" at "+DoubleToString(PositionGetDouble(POSITION_PRICE_OPEN), Digits());
      //write the results
      info[cnt]=inf;
      tickets[cnt]=0;
      //increment the counter
      cnt++;
     }

   //all orders
   for(int i=0;i<OrdersTotal();i++)
     {
      //get ticket
      ulong ticket=OrderGetTicket(i);
      //if order symbol is equal to chart symbol
      if(OrderGetString(ORDER_SYMBOL)==Symbol())
        {
         //combine all order infomation in a single line
         inf="#"+IntegerToString(ticket)+" ";
         int typ=int(OrderGetInteger(ORDER_TYPE));
         double vol=OrderGetDouble(ORDER_VOLUME_CURRENT);
         if(typ==ORDER_TYPE_BUY_LIMIT) inf+="BUY LIMIT ";
         if(typ==ORDER_TYPE_SELL_LIMIT) inf+="SELL LIMIT ";
         if(typ==ORDER_TYPE_BUY_STOP) inf+="BUY STOP ";
         if(typ==ORDER_TYPE_SELL_STOP) inf+="SELL STOP ";
         if(typ==ORDER_TYPE_BUY_STOP_LIMIT) inf+="BUY STOP LIMIT ";
         if(typ==ORDER_TYPE_SELL_STOP_LIMIT) inf+="SELL STOP LIMIT ";
         inf+=DoubleToString(vol, int(MathCeil(MathAbs(MathLog(vol)/MathLog(10)))))+" lots";
         inf+=" at "+DoubleToString(OrderGetDouble(ORDER_PRICE_OPEN), Digits());
         //write the results
         info[cnt]=inf;
         tickets[cnt]=ticket;
         //increment the counter
         cnt++;
        }
     }
  }
//+------------------------------------------------------------------+
//| Tab processor                                                    |
//| ID - index of clicked tab                                        |
//+------------------------------------------------------------------+
void Main_controls_click(int ID)
  {
   int loaded=ID;
   //we will go all tabs
   for(int i=1;i<6;i++)
     {
      //for all except the selected set inactive
      if(i!=ID) 
        {
         //also remember the last active tab
         if(ObjectGetInteger(0,"ActP_main_"+IntegerToString(i),OBJPROP_STATE)==1) loaded=i;
         ObjectSetInteger(0,"ActP_main_"+IntegerToString(i),OBJPROP_STATE,0);
        }
     }
//if(loaded==ID) return;
   //set an active state for the selected
   ObjectSetInteger(0,"ActP_main_"+IntegerToString(ID),OBJPROP_STATE,1);
   //delete the drop-down lists
   DeleteLists("ActP_orders_list_"); 
   DeleteLists("ActP_color_list_");
   //and set the list buttons to the unpressed state
   ObjectSetInteger(0,"ActP_ord_button5",OBJPROP_STATE,0);
   ObjectSetInteger(0,"ActP_col1_button6",OBJPROP_STATE,0);
   ObjectSetInteger(0,"ActP_col2_button6",OBJPROP_STATE,0);
   ObjectSetInteger(0,"ActP_col3_button6",OBJPROP_STATE,0);
   //save state of the last active tab
   SaveScheme(loaded);
   //remove old tab
   DeleteScheme("ActP");
   //and load a new
   ApplyScheme(ID);
   //Set all objects as unselected
   Objects_Selectable("ActP",false);
  }
//+------------------------------------------------------------------+
//| The function modifies an order                                   |
//| ticket - order ticket                                            |
//+------------------------------------------------------------------+
ulong modify_order(ulong ticket)
  {
   //get the order details from the corresponding chart objects
   double pr=StringToDouble(ObjectGetString(0,"ActP_Pr_edit3",OBJPROP_TEXT)); 
   double stoplim=StringToDouble(ObjectGetString(0,"ActP_limpr_edit3",OBJPROP_TEXT));
   double SL=StringToDouble(ObjectGetString(0, "ActP_SL_edit3", OBJPROP_TEXT));
   double TP=StringToDouble(ObjectGetString(0, "ActP_TP_edit3", OBJPROP_TEXT));
   double lots=StringToDouble(ObjectGetString(0,"ActP_Lots_edit3",OBJPROP_TEXT));
   datetime expir=StringToTime(ObjectGetString(0,"ActP_exp_edit3",OBJPROP_TEXT));
   ENUM_ORDER_TYPE_TIME expir_type=ORDER_TIME_GTC;
   if(ObjectGetInteger(0, "ActP_exp2_radio3", OBJPROP_STATE)==1) expir_type=ORDER_TIME_DAY;
   if(ObjectGetInteger(0, "ActP_exp3_radio3", OBJPROP_STATE)==1) expir_type=ORDER_TIME_SPECIFIED;

   //prepare request to modify
   MqlTradeRequest req;
   MqlTradeResult res;
   ZeroMemory(req);
   
   req.action=TRADE_ACTION_MODIFY;
   req.order=ticket;
   req.volume=lots;
   req.price=NormalizeDouble(pr,Digits());
   req.stoplimit=NormalizeDouble(stoplim,Digits());
   req.sl=NormalizeDouble(SL, Digits());
   req.tp=NormalizeDouble(TP, Digits());
   req.type_time=expir_type;
   req.expiration=expir;
   //send request
   OrderSend(req,res);
   //show message with the result
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //return retcode
   return(res.retcode);
  }
  
//+------------------------------------------------------------------+
//| The function for pending order deletion                          |
//| ticket - order ticket                                            |
//+------------------------------------------------------------------+
ulong del_order(ulong ticket)
  {
   //prepare request for deletion
   MqlTradeRequest req;
   MqlTradeResult res;
   ZeroMemory(req);
   req.action=TRADE_ACTION_REMOVE;
   req.order=ticket;
   //send request
   OrderSend(req,res);
   //show message with the result
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //return retcode
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//| The function modifies the position parameters                    |
//+------------------------------------------------------------------+
ulong modify_pos()
  {
   if(!PositionSelect(Symbol())) MessageBox("There isn't open position for symbol "+Symbol(),"Message");
   //get the details from the edit objects
   double SL=StringToDouble(ObjectGetString(0,"ActP_SL_edit4",OBJPROP_TEXT));  
   double TP=StringToDouble(ObjectGetString(0, "ActP_TP_edit4", OBJPROP_TEXT));
   int dev=int(StringToInteger(ObjectGetString(0,"ActP_dev_edit4",OBJPROP_TEXT)));
   //prepare request
   MqlTradeRequest req;
   MqlTradeResult res;  
   ZeroMemory(req);
   req.action=TRADE_ACTION_SLTP;
   req.symbol=Symbol();
   req.sl=NormalizeDouble(SL, _Digits);
   req.tp=NormalizeDouble(TP, _Digits);
   req.deviation=dev;
   //send request
   OrderSend(req,res);
   //show message with the result
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //return retcode
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//| Closes the position                                              |
//+------------------------------------------------------------------+
ulong close_pos()
  {
   if(!PositionSelect(Symbol())) MessageBox("There isn't open position for symbol "+Symbol(),"Message");
   //get the position details from the objects
   double lots=StringToDouble(ObjectGetString(0,"ActP_lots_edit4",OBJPROP_TEXT));
   if(lots>PositionGetDouble(POSITION_VOLUME)) lots=PositionGetDouble(POSITION_VOLUME);
   int dev=int(StringToInteger(ObjectGetString(0, "ActP_dev_edit4", OBJPROP_TEXT)));
   int mag=int(StringToInteger(ObjectGetString(0, "ActP_mag_edit4", OBJPROP_TEXT)));

   //prepare request
   MqlTradeRequest req;
   MqlTradeResult res;
   ZeroMemory(req);

   //the opposite deal is dependent on position type
   if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
     {
      req.price=Bid;
      req.type=ORDER_TYPE_SELL;
     }
   else
     {
      req.price=Ask;
      req.type=ORDER_TYPE_BUY;
     }

   req.action=TRADE_ACTION_DEAL;
   req.symbol=Symbol();
   req.volume=lots;
   req.sl=0;
   req.tp=0;
   req.deviation=dev;
   req.type_filling=ORDER_FILLING_FOK;
   req.magic=mag;
   //send request
   OrderSend(req,res);
   //show message with the result
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //return retcode
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//| Deal function                                                    |
//+------------------------------------------------------------------+
ulong deal(ENUM_ORDER_TYPE typ)
  {
   //get the data from the objects
   double SL=StringToDouble(ObjectGetString(0,"ActP_SL_edit1",OBJPROP_TEXT));
   double TP=StringToDouble(ObjectGetString(0, "ActP_TP_edit1", OBJPROP_TEXT));
   double lots=StringToDouble(ObjectGetString(0,"ActP_Lots_edit1",OBJPROP_TEXT));
   int mag=int(StringToInteger(ObjectGetString(0, "ActP_Magic_edit1", OBJPROP_TEXT)));
   int dev=int(StringToInteger(ObjectGetString(0, "ActP_Dev_edit1", OBJPROP_TEXT)));
   string comm=ObjectGetString(0,"ActP_Comm_edit1",OBJPROP_TEXT);
   ENUM_ORDER_TYPE_FILLING filling=ORDER_FILLING_FOK;
   if(ObjectGetInteger(0,"ActP_Exe2_radio1",OBJPROP_STATE)==1) filling=ORDER_FILLING_IOC;
   //prepare request
   MqlTradeRequest req;
   MqlTradeResult res;
   ZeroMemory(req);
   req.action=TRADE_ACTION_DEAL;
   req.symbol=Symbol();
   req.volume=lots;
   req.price=Ask;
   req.sl=NormalizeDouble(SL, Digits());
   req.tp=NormalizeDouble(TP, Digits());
   req.deviation=dev;
   req.type=typ;
   req.type_filling=filling;
   req.magic=mag;
   req.comment=comm;
   //send order
   OrderSend(req,res);
   //show message with the result
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //return retcode
   return(res.retcode);
  }
//+------------------------------------------------------------------+
//| The function places an order                                     |
//+------------------------------------------------------------------+
ulong order(ENUM_ORDER_TYPE typ)
  {
   //get the order details from the objects
   double pr=StringToDouble(ObjectGetString(0,"ActP_Pr_edit2",OBJPROP_TEXT));
   double stoplim=StringToDouble(ObjectGetString(0,"ActP_limpr_edit2",OBJPROP_TEXT));
   double SL=StringToDouble(ObjectGetString(0, "ActP_SL_edit2", OBJPROP_TEXT));
   double TP=StringToDouble(ObjectGetString(0, "ActP_TP_edit2", OBJPROP_TEXT));
   double lots=StringToDouble(ObjectGetString(0,"ActP_Lots_edit2",OBJPROP_TEXT));
   datetime expir=StringToTime(ObjectGetString(0,"ActP_exp_edit2",OBJPROP_TEXT));
   int mag=int(StringToInteger(ObjectGetString(0,"ActP_Magic_edit2",OBJPROP_TEXT)));
   string comm=ObjectGetString(0,"ActP_Comm_edit2",OBJPROP_TEXT);
   ENUM_ORDER_TYPE_FILLING filling=ORDER_FILLING_FOK;
   if(ObjectGetInteger(0, "ActP_Exe2_radio2", OBJPROP_STATE)==1) filling=ORDER_FILLING_IOC;
   if(ObjectGetInteger(0, "ActP_Exe3_radio2", OBJPROP_STATE)==1) filling=ORDER_FILLING_RETURN;
   ENUM_ORDER_TYPE_TIME expir_type=ORDER_TIME_GTC;
   if(ObjectGetInteger(0, "ActP_exp2_radio2", OBJPROP_STATE)==1) expir_type=ORDER_TIME_DAY;
   if(ObjectGetInteger(0, "ActP_exp3_radio2", OBJPROP_STATE)==1) expir_type=ORDER_TIME_SPECIFIED;

   //prepare request
   MqlTradeRequest req;
   MqlTradeResult res; 
   req.action=TRADE_ACTION_PENDING;
   req.symbol=Symbol();
   req.volume=lots;
   req.price=NormalizeDouble(pr,Digits());
   req.stoplimit=NormalizeDouble(stoplim,Digits());
   req.sl=NormalizeDouble(SL, Digits());
   req.tp=NormalizeDouble(TP, Digits());
   req.type=typ;
   req.type_filling=filling;
   req.type_time=expir_type;
   req.expiration=expir;
   req.comment=comm;
   req.magic=mag;
   //place order
   OrderSend(req,res);
   //show message with the result
   MessageBox(RetcodeDescription(res.retcode),"Message");
   //return retcode
   return(res.retcode);
  }
  

//+------------------------------------------------------------------+
//| The function for the interface loading                           |
//| ID - ID of the saved interface                                   |
//+------------------------------------------------------------------+
bool ApplyScheme(int ID)
  {
   string fname="Active_Panel_scheme_custom_"+IntegerToString(ID)+".bin";
   //download the standard scheme if there isn't saved scheme
   if(!FileIsExist(fname)) fname="Active_Panel_scheme_"+IntegerToString(ID)+".bin";
   //open file for reading
   int handle=FileOpen(fname,FILE_READ|FILE_BIN);
   //file opened
   if(handle!=INVALID_HANDLE)
     {
      //Loading all objects
      while(!FileIsEnding(handle))
        {
         string obj_name=FileReadString(handle,100);
         int _wnd=wnd;
         //the auxiliary lines are in the main window
         if(StringFind(obj_name,"line")>=0) _wnd=0;
         ENUM_OBJECT obj_type=ENUM_OBJECT (FileReadInteger(handle));
         //creating object
         ObjectCreate(0, obj_name, obj_type, _wnd, 0, 0);   
         //and apply the properties                                                   
         ObjectSetInteger(0,obj_name,OBJPROP_XDISTANCE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_YDISTANCE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_XSIZE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_YSIZE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_COLOR,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_STYLE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_WIDTH,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_BACK,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_SELECTED,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_SELECTABLE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_READONLY,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_FONTSIZE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_STATE,FileReadInteger(handle));
         ObjectSetInteger(0,obj_name,OBJPROP_BGCOLOR,FileReadInteger(handle));

         ObjectSetString(0,obj_name,OBJPROP_TEXT,FileReadString(handle,100));
         ObjectSetString(0,obj_name,OBJPROP_FONT,FileReadString(handle,100));
         ObjectSetString(0,obj_name,OBJPROP_BMPFILE,0,FileReadString(handle,100));
         ObjectSetString(0,obj_name,OBJPROP_BMPFILE,1,FileReadString(handle,100));

         ObjectSetDouble(0,obj_name,OBJPROP_PRICE,FileReadDouble(handle));

         //Set color for the bjects
         if(GlobalVariableCheck("ActP_buttons_color") && obj_type==OBJ_BUTTON)
            ObjectSetInteger(0,obj_name,OBJPROP_BGCOLOR,int(GlobalVariableGet("ActP_buttons_color")));
         if(GlobalVariableCheck("ActP_label_color") && obj_type==OBJ_LABEL)
            ObjectSetInteger(0,obj_name,OBJPROP_COLOR,int(GlobalVariableGet("ActP_label_color")));
         if(GlobalVariableCheck("ActP_text_color") && (obj_type==OBJ_EDIT || obj_type==OBJ_BUTTON))
            ObjectSetInteger(0,obj_name,OBJPROP_COLOR,int(GlobalVariableGet("ActP_text_color")));
         if(GlobalVariableCheck("ActP_font_size") && (obj_type==OBJ_EDIT || obj_type==OBJ_LABEL))
            ObjectSetInteger(0,obj_name,OBJPROP_FONTSIZE,int(GlobalVariableGet("ActP_font_size")));
         //Set global variable font size
         if(obj_name=="ActP_font_edit6" && GlobalVariableCheck("ActP_font_size"))
            ObjectSetString(0,obj_name,OBJPROP_TEXT,IntegerToString(int(GlobalVariableGet("ActP_font_size"))));
        }
      //close file
      FileClose(handle);
      return(true);
     }
   return(false);
  }

//+------------------------------------------------------------------+
//| Function of the interface creation                               |
//+------------------------------------------------------------------+
void create_interface()
  {
   //if reset settings is selected
   if(Reset_Expert_Settings)
     {
     //Reset
      GlobalVariableDel("ActP_buttons_color");
      GlobalVariableDel("ActP_label_color");
      GlobalVariableDel("ActP_text_color");
      GlobalVariableDel("ActP_font_size");
     }

   //Create the main menu interface
   ApplyScheme(0);
   //Create the interface tab "Market"
   ApplyScheme(1);
   //Set all objects as unmarked
   Objects_Selectable("ActP",false);
   //redraw the chart
   ChartRedraw();
  }
  
//+------------------------------------------------------------------+
//| Button creation function                                         |
//| name - button name                                               |
//| text - button text                                               |
//| X, Y, X_size, Y_size - button parameters                         |
//+------------------------------------------------------------------+
bool create_button(string name,string text,int X,int Y,int X_size,int Y_size)
  {
   //create button
   if(ObjectCreate(0,name,OBJ_BUTTON,wnd,0,0))
     {
      //and set its properties
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,X);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,Y);
      ObjectSetInteger(0,name,OBJPROP_XSIZE,X_size);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,Y_size);
      ObjectSetString(0,name,OBJPROP_FONT,"Arial");
      ObjectSetString(0,name,OBJPROP_TEXT,text);
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//| The function deletes all objects, that belongs to the panel      |
//| IDstr - ID-string                                                |
//+------------------------------------------------------------------+
void  ObjectsDeleteAll_my(string IDstr)
  {
   //look for all objects
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //delete an object, if there is an ID in the name
      if(StringFind(n,IDstr)>=0) ObjectDelete(0,n);
     }
  }
//+------------------------------------------------------------------+
//| The function sets all objects with ID as selectable/unselectable |
//+------------------------------------------------------------------+
void  Objects_Selectable(string IDstr,bool flag)
  {
   //look all objects
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //if the object belongs to the panel
      if(StringFind(n,IDstr)>=0)
        {
         //don't proceed the lines
         if(!flag)
            if(StringFind(n,"line")>-1) continue; 
         //set selectable property
         ObjectSetInteger(0,n,OBJPROP_SELECTABLE,flag); 
        }
     }
  }
//+------------------------------------------------------------------+
//| The function gets the information about the tick                 |
//+------------------------------------------------------------------+
void get_prices()
  {
   MqlTick tick;
   //the there was a tick
   if(SymbolInfoTick(Symbol(),tick))
     {
      //update info
      Bid=tick.bid;
      Ask=tick.ask;
      time_current=tick.time;
     }
  }
//+------------------------------------------------------------------+
//| The function deletes all the panel objects except tabs           |
//+------------------------------------------------------------------+
void  DeleteScheme(string IDstr)
  {
   //look all objects
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //delete all, except tabs
      if(StringFind(n,IDstr)>=0 && StringFind(n,"main")<0) ObjectDelete(0,n); 
     }
  }
//+------------------------------------------------------------------+
//| The function deletes all the panel objects except tabs           |
//| and order selection button                                       |
//+------------------------------------------------------------------+
void  DeleteScheme(string IDstr,bool fl)
  {
   //look all objects
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //if it list activation button, skip it
      if(fl && n=="ActP_ord_button5") continue; 
      //delete all exept tabs
      if(StringFind(n,IDstr)>=0 && StringFind(n,"main")<0) ObjectDelete(0,n);
     }
  }
//+------------------------------------------------------------------+
//| The function deletes lists                                       |
//+------------------------------------------------------------------+
void  DeleteLists(string IDstr)
  {
   //look all objects
   for(int i=ObjectsTotal(0);i>=0;i--)
     {
      string n=ObjectName(0,i);
      //delete lists
      if(StringFind(n,IDstr)>=0 && StringFind(n,"main")<0) ObjectDelete(0,n);
     }
  }
//+------------------------------------------------------------------+
//| The function removes the zeros at the endo of the string         |
//| str - string                                                     |
//+------------------------------------------------------------------+
string str_del_zero(string str)
  {
  //get string length
   int len=StringLen(str)-1;
   int pos=len;
   //scanning string
   for(int i=len;i>=0;i--)
     {
      //get char at the current position
      char symb=char(StringGetCharacter(str,i));
      //if it equal to dot - break the cycle
      if(symb=='.') {pos--; break;}
      //if 0 - save its position
      //overwise break
      if(symb=='0') pos=i; 
      else break;
     }
   //Substr string without zero chars
   str=StringSubstr(str,0,pos);
   return(str);
  }
//+------------------------------------------------------------------+
//| Interface saving function                                        |
//+------------------------------------------------------------------+
void SaveScheme(int interfaceID)
  {
   //open file for writing
   int handle=FileOpen("Active_Panel_scheme_custom_"+IntegerToString(interfaceID)+".bin",FILE_WRITE|FILE_BIN);
   //if file opened
   if(handle!=INVALID_HANDLE)
     {
      //go all the chart objects
      for(int i=0;i<ObjectsTotal(0);i++)
        {
         string name=ObjectName(0,i);
         //if the object belongs to the panel
         if(StringFind(name,"ActP")<0) continue;
         //and it isn't a tab
         if(StringFind(name,"main")>=0) continue; 
         //write the object properties to a file
         FileWriteString(handle,name,100);
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_TYPE)));

         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_XDISTANCE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_YDISTANCE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_XSIZE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_YSIZE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_COLOR)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_STYLE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_WIDTH)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_BACK)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_SELECTED)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_SELECTABLE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_READONLY)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_FONTSIZE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_STATE)));
         FileWriteInteger(handle,int(ObjectGetInteger(0,name,OBJPROP_BGCOLOR)));

         FileWriteString(handle,ObjectGetString(0,name,OBJPROP_TEXT),100);
         FileWriteString(handle,ObjectGetString(0,name,OBJPROP_FONT),100);
         FileWriteString(handle,ObjectGetString(0,name,OBJPROP_BMPFILE,0),100);
         FileWriteString(handle,ObjectGetString(0,name,OBJPROP_BMPFILE,1),100);

         FileWriteDouble(handle,ObjectGetDouble(0,name,OBJPROP_PRICE));
        }
      //close file  
      FileClose(handle);
     }
  }
//+------------------------------------------------------------------+
color colors[132]=
  {
   Black,
   DarkGreen,
   DarkSlateGray,
   Olive,
   Green,
   Teal,
   Navy,
   Purple,
   Maroon,
   Indigo,
   MidnightBlue,
   DarkBlue,
   DarkOliveGreen,
   SaddleBrown,
   ForestGreen,
   OliveDrab,
   SeaGreen,
   DarkGoldenrod,
   DarkSlateBlue,
   Sienna,
   MediumBlue,
   Brown,
   DarkTurquoise,
   DimGray,
   LightSeaGreen,
   DarkViolet,
   FireBrick,
   MediumVioletRed,
   MediumSeaGreen,
   Chocolate,
   Crimson,
   SteelBlue,
   Goldenrod,
   MediumSpringGreen,
   LawnGreen,
   CadetBlue,
   DarkOrchid,
   YellowGreen,
   LimeGreen,
   OrangeRed,
   DarkOrange,
   Orange,
   Gold,
   Yellow,
   Chartreuse,
   Lime,
   SpringGreen,
   Aqua,
   DeepSkyBlue,
   Blue,
   Magenta,
   Red,
   Gray,
   SlateGray,
   Peru,
   BlueViolet,
   LightSlateGray,
   DeepPink,
   MediumTurquoise,
   DodgerBlue,
   Turquoise,
   RoyalBlue,
   SlateBlue,
   DarkKhaki,
   IndianRed,
   MediumOrchid,
   GreenYellow,
   MediumAquamarine,
   DarkSeaGreen,
   Tomato,
   RosyBrown,
   Orchid,
   MediumPurple,
   PaleVioletRed,
   Coral,
   CornflowerBlue,
   DarkGray,
   SandyBrown,
   MediumSlateBlue,
   Tan,
   DarkSalmon,
   BurlyWood,
   HotPink,
   Salmon,
   Violet,
   LightCoral,
   SkyBlue,
   LightSalmon,
   Plum,
   Khaki,
   LightGreen,
   Aquamarine,
   Silver,
   LightSkyBlue,
   LightSteelBlue,
   LightBlue,
   PaleGreen,
   Thistle,
   PowderBlue,
   PaleGoldenrod,
   PaleTurquoise,
   LightGray,
   Wheat,
   NavajoWhite,
   Moccasin,
   LightPink,
   Gainsboro,
   PeachPuff,
   Pink,
   Bisque,
   LightGoldenrod,
   BlanchedAlmond,
   LemonChiffon,
   Beige,
   AntiqueWhite,
   PapayaWhip,
   Cornsilk,
   LightYellow,
   LightCyan,
   Linen,
   Lavender,
   MistyRose,
   OldLace,
   WhiteSmoke,
   Seashell,
   Ivory,
   Honeydew,
   AliceBlue,
   LavenderBlush,
   MintCream,
   Snow,
   White
  };
//+------------------------------------------------------------------+
//| The function returns server return code description              |
//+------------------------------------------------------------------+
string RetcodeDescription(int retcode)
  {
   string str;
//---
   switch(retcode)
     {
      case TRADE_RETCODE_REQUOTE:
         str="Requote";
         break;
      case TRADE_RETCODE_REJECT:
         str="Request rejected";
         break;
      case TRADE_RETCODE_CANCEL:
         str="Request cancelled by trader";
         break;
      case TRADE_RETCODE_PLACED:
         str="Order placed";
         break;
      case TRADE_RETCODE_DONE:
         str="Request done";
         break;
      case TRADE_RETCODE_DONE_PARTIAL:
         str="Request done partially";
         break;
      case TRADE_RETCODE_ERROR:
         str="Common error";
         break;
      case TRADE_RETCODE_TIMEOUT:
         str="Request cancelled by timeout";
         break;
      case TRADE_RETCODE_INVALID:
         str="Invalid request";
         break;
      case TRADE_RETCODE_INVALID_VOLUME:
         str="Invalid volume in request";
         break;
      case TRADE_RETCODE_INVALID_PRICE:
         str="Invalid price in request";
         break;
      case TRADE_RETCODE_INVALID_STOPS:
         str="Invalid stop(s) request";
         break;
      case TRADE_RETCODE_TRADE_DISABLED:
         str="Trade is disabled";
         break;
      case TRADE_RETCODE_MARKET_CLOSED:
         str="Market is closed";
         break;
      case TRADE_RETCODE_NO_MONEY:
         str="Not enough money";
         break;
      case TRADE_RETCODE_PRICE_CHANGED:
         str="Price changed";
         break;
      case TRADE_RETCODE_PRICE_OFF:
         str="No quotes for query processing";
         break;
      case TRADE_RETCODE_INVALID_EXPIRATION:
         str="Invalid expiration time in request";
         break;
      case TRADE_RETCODE_ORDER_CHANGED:
         str="Order state changed";
         break;
      case TRADE_RETCODE_TOO_MANY_REQUESTS:
         str="Too frequent requests";
         break;
      case TRADE_RETCODE_NO_CHANGES:
         str="No changes in request";
         break;
      case TRADE_RETCODE_SERVER_DISABLES_AT:
         str="Autotrading disabled by server";
         break;         
      case TRADE_RETCODE_CLIENT_DISABLES_AT:
         str="Autotrading disabled by client terminal";
         break;         
      case TRADE_RETCODE_LOCKED:
         str="Request locked for processing";
         break;
      case TRADE_RETCODE_FROZEN:
         str="Order or position frozen";
         break;        
      case TRADE_RETCODE_INVALID_FILL:
         str="Invalid order filling type";
         break;
      case TRADE_RETCODE_CONNECTION:
         str="No connection with the trade server";
         break;              
      default:
         str="Unknown result";
     }
//---
   return(str);
  }
//+------------------------------------------------------------------+